searchNodes=[{"doc":"This moduledoc is provided to give insight into the ideal working shape of the MapList. It is not yet implemented. There's literally nothing to see here as of now, besides this, what is very possibly the first ever recorded instance of technical documentation fiction.Functions for interacting with a list of data in an indexed manner. Because Maps are not a lightweight structure, this module is recommended for edge cases in which normal traversal of a List would otherwise be too time inefficient for frequent tasks.MapLists are implemented to behave as a List in almost all cases. The notable exception being that a MapList provides a tuple of {index, item} to its implementation of Enumerable, and always returns a MapList for further transformation. To get the list of items from a MapList, use MapList.values/1. You can also call MapList.to_list/1 to get a list of the {index, item} pairs.iex&gt; MapList.new([&quot;Hello&quot;,&quot;elixir&quot;,&quot;world!&quot;]) %MapList[&quot;Hello&quot;, &quot;elixir&quot;, &quot;world!&quot;]Since MapLists can't be destructured, functions are provided to apply transformations to them. Adding elements to either the head or the tail of a MapList can be done quickly, as indices will not need to be internally recalculated in these operations.iex&gt; map_list = MapList.push(MapList.new([1,2,3,4]), 5) %MapList[1, 2, 3, 4, 5] iex&gt; map_list = MapList.unshift(map_list, 0) %MapList[0, 1, 2, 3, 4, 5]Removing elements from the head or tail is similarly fast.iex&gt; map_list = MapList.new(1..10) %MapList[1, 2, 3, 4, 5, 6, 7, 8, 9, 10] iex&gt; {last, map_list} = MapList.pop(map_list) {10, %MapList[1, 2, 3, 4, 5, 6, 7, 8, 9]} iex&gt; {first, map_list} = MapList.shift {1, %MapList[2, 3, 4, 5, 6, 7, 8, 9]}Replacing an element in the middle of the MapList is similarly uncostly, but inserting or removing an element from the middle of a MapList will cause the indices to be internally recalculated, to avoid requiring to traverse and ignore a sentinel value (or stop at the sentinel value, as parts of the :array module do).iex&gt; map_list = MapList.new(~W&quot;Hello elixir world!&quot;) ...&gt; |&gt; MapList.insert_at(1, &quot;brave&quot;) %MapList[&quot;Hello&quot;, &quot;brave&quot;, &quot;elixir&quot;, &quot;world!&quot;] iex&gt; map_list ...&gt; |&gt; MapList.replace_at(1, &quot;awesome&quot;) %MapList[&quot;Hello&quot;, &quot;awesome&quot;, &quot;elixir&quot;, &quot;world!&quot;]","ref":"MapList.html","title":"MapList","type":"module"},{"doc":"Helper modules for performing tasks not covered by the Elixir standard libraryInspired by the Ruby gem active_support, passive_support aims to enable developers to have a utility belt attached to their toolchain. ... Or ... some similar metaphor, but that makes much more sense.","ref":"PassiveSupport.html","title":"PassiveSupport","type":"module"},{"doc":"","ref":"PassiveSupport.Atom.html","title":"PassiveSupport.Atom","type":"module"},{"doc":"Returns true if the passed-in value resembles an existing atom and false if it does not.Examplesiex&gt; exists?(:foo) true iex&gt; exists?(&quot;yes&quot;) true iex&gt; exists?(&quot;bar&quot;) false iex&gt; exists?(&quot;false&quot;) true iex&gt; exists?(&quot;nil&quot;) true","ref":"PassiveSupport.Atom.html#exists?/1","title":"PassiveSupport.Atom.exists?/1","type":"function"},{"doc":"If able, casts the string to an existing atom, returning nil if not.Examplesiex&gt; from_string(&quot;ok&quot;) :ok iex&gt; from_string(&quot;error&quot;) :error iex&gt; from_string(&quot;true&quot;) true iex&gt; from_string(&quot;false&quot;) false iex&gt; from_string(&quot;nil&quot;) # `nil` is, itself, an atom nil iex&gt; from_string(&quot;what&#39;s all this then?&quot;) nil","ref":"PassiveSupport.Atom.html#from_string/1","title":"PassiveSupport.Atom.from_string/1","type":"function"},{"doc":"","ref":"PassiveSupport.Blank.html","title":"PassiveSupport.Blank","type":"protocol"},{"doc":"","ref":"PassiveSupport.Blank.html#blank?/1","title":"PassiveSupport.Blank.blank?/1","type":"function"},{"doc":"","ref":"PassiveSupport.Blank.html#t:t/0","title":"PassiveSupport.Blank.t/0","type":"type"},{"doc":"","ref":"PassiveSupport.Enum.html","title":"PassiveSupport.Enum","type":"module"},{"doc":"Deep-converts enum to a list.Examplesiex&gt; deep_to_list(%{&quot;game_types&quot; =&gt; [&quot;card&quot;], &quot;rulesets_known&quot; =&gt; [%{&quot;poker&quot; =&gt; &quot;texas hold &#39;em&quot;, &quot;hearts&quot; =&gt; true}]}) [{&quot;game_types&quot;, [&quot;card&quot;]}, {&quot;rulesets_known&quot;, [[{&quot;hearts&quot;, true}, {&quot;poker&quot;, &quot;texas hold &#39;em&quot;}]]}]","ref":"PassiveSupport.Enum.html#deep_to_list/1","title":"PassiveSupport.Enum.deep_to_list/1","type":"function"},{"doc":"Returns true if the given fun evaluates to false on all of the items in the enumberable.Iteration stops at the first invocation that returns a truthy value (not false or nil). Invokes an identity function if one is not provided.Examplesiex&gt; test_list = [1, 2, 3] ...&gt; none?(test_list, &amp;(&amp;1 == 0)) true ...&gt; none?([0 | test_list], &amp;(&amp;1 == 0)) false iex&gt; none?([]) true iex&gt; none?([nil]) true iex&gt; none?([true]) false","ref":"PassiveSupport.Enum.html#none?/2","title":"PassiveSupport.Enum.none?/2","type":"function"},{"doc":"Generates a list of all possible permutations of the given enumerable.Examplesiex&gt; permutations(~w&quot;hi ho hey!&quot;) [ [&quot;hi&quot;, &quot;ho&quot;, &quot;hey!&quot;], [&quot;hi&quot;, &quot;hey!&quot;, &quot;ho&quot;], [&quot;ho&quot;, &quot;hi&quot;, &quot;hey!&quot;], [&quot;ho&quot;, &quot;hey!&quot;, &quot;hi&quot;], [&quot;hey!&quot;, &quot;hi&quot;, &quot;ho&quot;], [&quot;hey!&quot;, &quot;ho&quot;, &quot;hi&quot;] ]","ref":"PassiveSupport.Enum.html#permutations/1","title":"PassiveSupport.Enum.permutations/1","type":"function"},{"doc":"Converts an enumerable to a Map, using the index of each item as the item's key.Examplesiex&gt; to_map([&quot;hello&quot;, &quot;world&quot;, &quot;how&quot;, &quot;are&quot;, &quot;you&quot;]) %{0 =&gt; &quot;hello&quot;, 1 =&gt; &quot;world&quot;, 2 =&gt; &quot;how&quot;, 3 =&gt; &quot;are&quot;, 4 =&gt; &quot;you&quot;} iex&gt; to_map([&quot;Elixir&quot;, &quot;is&quot;, &quot;cool&quot;]) %{0 =&gt; &quot;Elixir&quot;, 1 =&gt; &quot;is&quot;, 2 =&gt; &quot;cool&quot;}","ref":"PassiveSupport.Enum.html#to_map/1","title":"PassiveSupport.Enum.to_map/1","type":"function"},{"doc":"Not to be confused with Enum.map/2, returns a Map with the key for each item derived by the return of key_function(item) or key_function(item, index)Examplesiex&gt; to_map([&quot;Elixir&quot;, &quot;is&quot;, &quot;cool&quot;], &amp;String.reverse/1) %{&quot;si&quot; =&gt; &quot;is&quot;, &quot;looc&quot; =&gt; &quot;cool&quot;, &quot;rixilE&quot; =&gt; &quot;Elixir&quot;} iex&gt; to_map([&quot;hello&quot;, &quot;world&quot;, &quot;how&quot;, &quot;are&quot;, &quot;you&quot;], fn (_, index) -&gt; index end) %{0 =&gt; &quot;hello&quot;, 1 =&gt; &quot;world&quot;, 2 =&gt; &quot;how&quot;, 3 =&gt; &quot;are&quot;, 4 =&gt; &quot;you&quot;}","ref":"PassiveSupport.Enum.html#to_map/2","title":"PassiveSupport.Enum.to_map/2","type":"function"},{"doc":"","ref":"PassiveSupport.Integer.html","title":"PassiveSupport.Integer","type":"module"},{"doc":"Arbitrary-precision exponentiation.Will be deprecated by Elixir v1.12.0Examplesiex&gt; exponential(2, 10) 1024 iex&gt; exponential(3, 3) 27 iex&gt; exponential(2, 100) 1267650600228229401496703205376 iex&gt; exponential(5, -3) 0.008 iex&gt; exponential(9832, 0) 1 iex&gt; exponential(0, 2) 0 iex&gt; exponential(0, 0) 1","ref":"PassiveSupport.Integer.html#exponential/2","title":"PassiveSupport.Integer.exponential/2","type":"function"},{"doc":"Arbitrary-precision factorial.Examplesiex&gt; factorial(5) 120 iex&gt; factorial(6) 720 iex&gt; factorial(-6) -720 iex&gt; factorial(1) 1","ref":"PassiveSupport.Integer.html#factorial/1","title":"PassiveSupport.Integer.factorial/1","type":"function"},{"doc":"Converts an integer to a string, with a separator (default &quot;,&quot;) inserted, starting in from the right side of the number, spaced apart by the number of digits specified by spacing (default 3).Examplesiex&gt; formatted(57468291379) &quot;57,468,291,379&quot; iex&gt; formatted(57468291379, separator: &quot;_&quot;) &quot;57_468_291_379&quot; iex&gt; formatted(57468291379, spacing: 4) &quot;574,6829,1379&quot;","ref":"PassiveSupport.Integer.html#formatted/2","title":"PassiveSupport.Integer.formatted/2","type":"function"},{"doc":"Qualifies if integer is an integer less than 0.","ref":"PassiveSupport.Integer.html#is_negative/1","title":"PassiveSupport.Integer.is_negative/1","type":"macro"},{"doc":"Qualifies if integer is a natural number or 0.","ref":"PassiveSupport.Integer.html#is_nonnegative/1","title":"PassiveSupport.Integer.is_nonnegative/1","type":"macro"},{"doc":"Qualifies if integer is an integer greater than 0.(adhering to the mathematical principle that 0 is neither positive nor negative)","ref":"PassiveSupport.Integer.html#is_positive/1","title":"PassiveSupport.Integer.is_positive/1","type":"macro"},{"doc":"Returns the quotient and the remainder of dividend ÷ divisorExamplesiex&gt; remdiv(3, 2) {1, 1} iex&gt; remdiv(-325, 60) {-5, -25} iex&gt; remdiv(11, 3) {3, 2}","ref":"PassiveSupport.Integer.html#remdiv/2","title":"PassiveSupport.Integer.remdiv/2","type":"function"},{"doc":"Functions for handling arbitrary-shape values.","ref":"PassiveSupport.Item.html","title":"PassiveSupport.Item","type":"module"},{"doc":"Returns true of any value that would return true with Enum.empty?/1, as well as to bare tuples, binaries with no data, and strings containing only whitespace, nil, and false. Returns false for any other value.Note that while a string containing only whitespace can be considered blank, a charlist of the same nature will return false. Because charlists are represented internally as lists of integers, a charlist of whitespace would be indescernible from a list of numeric integers, neither of which would be individually considered blank, and therefore should not be regarded as blank in tandem.Examplesiex&gt; blank?({}) true iex&gt; blank?(%{}) true iex&gt; blank?(MapSet.new()) true iex&gt; blank?(0) false iex&gt; blank?(nil) true iex&gt; blank?(false) true iex&gt; blank?(&quot; &quot;) true iex&gt; blank?(&#39; &#39;) # [32, 32] false iex&gt; blank?(&quot; hi &quot;) false","ref":"PassiveSupport.Item.html#blank?/1","title":"PassiveSupport.Item.blank?/1","type":"function"},{"doc":"Traverses into item through an arbitrary path of keys and indices.Think of dig/3 as an extension of the concept at the heart of Access.get/3. There are times when the data you're working with is a deeply-nested structure, and your bigger concern is what a specific part of that data looks like. In cases where you are working with one sort of data type (e.g., maps, structs, tuples, or lists), then you know you can use the same function or macro to dig down through each successive layer of nested data. However, when working with disparate data types, keeping track of the structure of each level of the nested data becomes an exercise in both patience, and trial and error.The assurance dig/3 provides is that, until arriving at a leaf node within item or fully traversing through path, the function will retrieve the element of item at the next point within path, dispatching to the correct function for doing so based on the structure of the data at the current level of traversal. If dig arrives at a nil value at any point in traversal, the remainder of the path is dropped, and the value provided as default (which, by custom, defaults to nil itself) is immediately returned to the caller.Note: The only event in which this function will raise an exception is when it attempts to traverse the path of a scalar value. To guarantee consistency in the traversal rules, trying to traverse a tuple with an out-of-bounds index results in nil being returned instead of an ArgumentError being raised. Similarly, attempting to dig into a struct at a keyword that it doesn't define will return nil instead of raising a KeyError. For exception propagation, use dig!/3 instead.Examplesiex&gt; pets = %{ ...&gt; cats: [ ...&gt; %{name: &quot;Lester&quot;, favorite_toy: &quot;feather&quot;}, ...&gt; %{name: &quot;Janice&quot;, favorite_toy: &quot;laser pointer&quot;} ...&gt; ], ...&gt; dogs: [ ...&gt; %{name: &quot;Scrump&quot;, favorite_toy: &quot;rope&quot;}, ...&gt; %{name: &quot;Stitch&quot;, favorite_toy: &quot;ball&quot;} ...&gt; ], ...&gt; hyenas: [ ...&gt; %{&quot;what is this&quot; =&gt; &quot;oh no&quot;, &quot;hyenas can&#39;t be pets&quot; =&gt; &quot;too wild&quot;} ...&gt; ] ...&gt; } iex&gt; dig(pets, [:dogs]) [%{name: &quot;Scrump&quot;, favorite_toy: &quot;rope&quot;}, %{name: &quot;Stitch&quot;, favorite_toy: &quot;ball&quot;}] iex&gt; dig(pets, [:cats, 1]) %{name: &quot;Janice&quot;, favorite_toy: &quot;laser pointer&quot;} iex&gt; dig(pets, [:hyenas, 0, &quot;what is this&quot;]) &quot;oh no&quot; iex&gt; dig(pets, [:dogs, 0, :favorite_food, :ingredients]) nilYou can also use dig through lists of nested data structures by passing an empty list [] as a part of path.iex&gt; connor_family = [ ...&gt; {&quot;Sarah&quot;, %{favorite_movies: [&quot;Dr. Strangelove&quot;, &quot;China Town&quot;, &quot;Citizen Kane&quot;]}}, ...&gt; {&quot;John&quot;, %{favorite_movies: [&quot;Tron&quot;, &quot;Star Wars&quot;, &quot;The Fifth Element&quot;]}}, ...&gt; {&quot;Cameron&quot;, %{favorite_movies: [&quot;Robocop&quot;, &quot;Logan&#39;s Run&quot;, &quot;The Animatrix - The Second Renaissance Part 2&quot;]}} ...&gt; ] iex&gt; dig(connor_family, [[], 1, :favorite_movies, 2]) [&quot;Citizen Kane&quot;, &quot;The Fifth Element&quot;, &quot;The Animatrix - The Second Renaissance Part 2&quot;]","ref":"PassiveSupport.Item.html#dig/3","title":"PassiveSupport.Item.dig/3","type":"function"},{"doc":"Returns nil for any blank?/1 value, and returns the value back otherwise.Examplesiex&gt; presence({}) nil iex&gt; presence(%{}) nil iex&gt; presence(nil) nil iex&gt; presence(false) nil iex&gt; presence([false]) [false] iex&gt; presence(&quot; &quot;) nil iex&gt; presence(&quot; hi &quot;) &quot; hi &quot;","ref":"PassiveSupport.Item.html#presence/1","title":"PassiveSupport.Item.presence/1","type":"function"},{"doc":"Returns true of any value that is not blank?/1Examplesiex&gt; present?({}) false iex&gt; present?(%{}) false iex&gt; present?(MapSet.new(1..10)) false iex&gt; present?(0) true iex&gt; present?(nil) false iex&gt; present?(false) false iex&gt; present?(&quot; &quot;) false iex&gt; present?(&#39; &#39;) true iex&gt; present?(&quot; hi &quot;) true","ref":"PassiveSupport.Item.html#present?/1","title":"PassiveSupport.Item.present?/1","type":"function"},{"doc":"Calls fun.(item), returning item with any transformations done therein.Basically, I got tired of not being able to pipe a value into arbitrary positions of other functions.Examplesiex&gt; &quot;, &quot; |&gt; Item.tap(&amp;Enum.join(1..10, &amp;1)) &quot;1, 2, 3, 4, 5, 6, 7, 8, 9, 10&quot; iex&gt; false |&gt; Item.tap(&amp;(unless &amp;1, do: &quot;oh!&quot;)) &quot;oh!&quot; iex&gt; [5, 4, 3, 2, 1] |&gt; hd |&gt; Item.tap(&amp;(&amp;1 * &amp;1)) 25 iex&gt; &quot;hello world!&quot; |&gt; Item.tap(&amp;Regex.scan(~r/lo?/, &amp;1)) [[&quot;l&quot;], [&quot;lo&quot;], [&quot;l&quot;]]","ref":"PassiveSupport.Item.html#tap/2","title":"PassiveSupport.Item.tap/2","type":"function"},{"doc":"Calls fun.(item) and returns item unaltered.This function mimics the tee program in shell systems, allowing a copy of the passed-in item to be sent to another function amid a pipeline of other functions that are transforming it or handing it off for another value.Examples1..10 |&gt; Enum.to_list |&gt; tee(&amp;Logger.info(inspect(&amp;1, label: &quot;`1..10` as a list&quot;))) # (… output from Logger …) # =&gt; [1, 2, 3, 4, 5, 6, 7, 8, 9, 10] some_data |&gt; tee(&amp;IO.inspect(&amp;1, label: &quot;encoding as json&quot;)) |&gt; Jason.encode! # =&gt; JSON-encoded data","ref":"PassiveSupport.Item.html#tee/2","title":"PassiveSupport.Item.tee/2","type":"function"},{"doc":"","ref":"PassiveSupport.Item.html#t:key_or_index/0","title":"PassiveSupport.Item.key_or_index/0","type":"type"},{"doc":"","ref":"PassiveSupport.Item.html#t:t/0","title":"PassiveSupport.Item.t/0","type":"type"},{"doc":"","ref":"PassiveSupport.Item.html#t:traversable/0","title":"PassiveSupport.Item.traversable/0","type":"type"},{"doc":"","ref":"PassiveSupport.List.html","title":"PassiveSupport.List","type":"module"},{"doc":"Returns a copy of list with any nil values removedExamplesiex&gt; compact([1,nil,3]) [1, 3] iex&gt; compact([false, nil, nil, &quot;hi&quot;]) [false, &quot;hi&quot;]","ref":"PassiveSupport.List.html#compact/1","title":"PassiveSupport.List.compact/1","type":"function"},{"doc":"Performs the provided function on every non-nil value while removing nil values. If also_filter_result is passed, then any nil values that would be returned from the function are not injected into the list.Examplesiex&gt; compact_map([1,2,nil,4], &amp;(&amp;1 * 2)) [2,4,8] iex&gt; compact_map([nil, &quot; &quot;, {}, 0], &amp;PassiveSupport.Item.presence/1, also_filter_result: true) [0] iex&gt; compact_map([nil, false, 0], &amp;(&amp;1), also_filter_result: true) [false, 0]","ref":"PassiveSupport.List.html#compact_map/3","title":"PassiveSupport.List.compact_map/3","type":"function"},{"doc":"Returns a new list of [item | list] An antonym to hd.Examplesiex&gt; cons([2,3], 1) [1,2,3] iex&gt; [2,3] |&gt; cons(1) |&gt; cons(0) [0,1,2,3]","ref":"PassiveSupport.List.html#cons/2","title":"PassiveSupport.List.cons/2","type":"function"},{"doc":"Helper functions for logging and inspecting.These functions serve two primary purposes:To keep outputs colorized even when they're sent to Logger,To keep IO.inspect and Kernel.inspect from truncating away data you might need if you intend, e.g., to save a function's return as fixture data for debugging purposes","ref":"PassiveSupport.Logging.html","title":"PassiveSupport.Logging","type":"module"},{"doc":"","ref":"PassiveSupport.Logging.html#alert/2","title":"PassiveSupport.Logging.alert/2","type":"function"},{"doc":"Pretty good, pretty pretty, color choices for inspected data","ref":"PassiveSupport.Logging.html#coloration_opts/0","title":"PassiveSupport.Logging.coloration_opts/0","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#critical/2","title":"PassiveSupport.Logging.critical/2","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#debug/2","title":"PassiveSupport.Logging.debug/2","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#emergency/2","title":"PassiveSupport.Logging.emergency/2","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#error/2","title":"PassiveSupport.Logging.error/2","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#info/2","title":"PassiveSupport.Logging.info/2","type":"function"},{"doc":"calls Kernel.inspect/2 on item with logger_opts/0.If you wish to overwrite some portion of the opts send to inspect, consider calling Kernel.inspect and passing Utils.logger_opts() ++ overwrites as your opts instead of calling this function.","ref":"PassiveSupport.Logging.html#inspect/2","title":"PassiveSupport.Logging.inspect/2","type":"function"},{"doc":"Sensible defaults for IO.inspect and Kernel.inspect when you want to see a value in its entirety","ref":"PassiveSupport.Logging.html#inspect_opts/0","title":"PassiveSupport.Logging.inspect_opts/0","type":"function"},{"doc":"Sensible option defaults for logging information to stdout","ref":"PassiveSupport.Logging.html#logger_opts/0","title":"PassiveSupport.Logging.logger_opts/0","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#notice/2","title":"PassiveSupport.Logging.notice/2","type":"function"},{"doc":"","ref":"PassiveSupport.Logging.html#warn/2","title":"PassiveSupport.Logging.warn/2","type":"function"},{"doc":"Convenience functions for working with maps.","ref":"PassiveSupport.Map.html","title":"PassiveSupport.Map","type":"module"},{"doc":"Returns map with its keys as atoms, if those atoms already exist.Raises ArgumentError otherwise.Examplesiex&gt; [:oh, :yay] # existing keys iex&gt; atomize_keys!(%{&quot;oh&quot; =&gt; &quot;ooh&quot;, &#39;yay&#39; =&gt; &#39;yaaay&#39;}) %{oh: &quot;ooh&quot;, yay: &#39;yaaay&#39;} iex&gt; atomize_keys!(%{&quot;oh&quot; =&gt; &quot;ooh&quot;, &quot;noo&quot; =&gt; &quot;noooo&quot;}) ** (PassiveSupport.NonexistentAtoms) No atoms exist for the values [&quot;noo&quot;]","ref":"PassiveSupport.Map.html#atomize_keys!/1","title":"PassiveSupport.Map.atomize_keys!/1","type":"function"},{"doc":"Returns a new map with key replaced by new_key or the return of funIf key is not found within map, returns the map unaltered.Useful for when you're shuffling values around inside of a map, or, I dunno, going through your music collection and you discover you accidentally attributed an entire Beatles album to the Monkees.Although how you did that is beyond me. You monster.Examplesiex&gt; change_key(%{dog: &quot;rusty&quot;}, :dog, :cat) %{cat: &quot;rusty&quot;} iex&gt; change_key(%{dog: &quot;rusty&quot;}, :dog, &amp;(:&quot;best_\#{&amp;1}&quot;)) %{best_dog: &quot;rusty&quot;} iex&gt; change_key(%{1 =&gt; &quot;foo&quot;, 2 =&gt; &quot;bar&quot;, 5 =&gt; &quot;idklol&quot;}, 1, fn _key, map -&gt; Enum.max(Map.keys(map)) + 1 end) %{2 =&gt; &quot;bar&quot;, 5 =&gt; &quot;idklol&quot;, 6 =&gt; &quot;foo&quot;} iex&gt; change_key(%{cake_boss: &quot;you blew it&quot;}, :no_key_here, :oops) %{cake_boss: &quot;you blew it&quot;}","ref":"PassiveSupport.Map.html#change_key/3","title":"PassiveSupport.Map.change_key/3","type":"function"},{"doc":"Deletes the struct metadata from structs, but leaves ordinary maps unchangedExamplesPassiveSupport.Map.plain(%{foo: :bar}) # =&gt; %{foo: :bar} defmodule Plane do defstruct plains: :great # ... little plain punning for ya. end PassiveSupport.Map.plain(%Plane{}) # =&gt; %{plains: :great}","ref":"PassiveSupport.Map.html#plain/1","title":"PassiveSupport.Map.plain/1","type":"function"},{"doc":"Returns a map with any string keys that safely coerced to existing atomsI'm not giving y'all the ridiculously dangerous footgun of wanton atom space pollution. I'm not some crazy, foot-shooting cowboy, like Jason.Examplesiex&gt; [:oh, :yay] # existing keys iex&gt; safe_atomize_keys(%{&quot;oh&quot; =&gt; &quot;ooh&quot;, &#39;yay&#39; =&gt; &#39;yaaay&#39;}) %{oh: &quot;ooh&quot;, yay: &#39;yaaay&#39;} iex&gt; safe_atomize_keys(%{&quot;oh&quot; =&gt; &quot;ooh&quot;, &quot;noo&quot; =&gt; &quot;noooo&quot;}) %{oh: &quot;ooh&quot;}","ref":"PassiveSupport.Map.html#safe_atomize_keys/1","title":"PassiveSupport.Map.safe_atomize_keys/1","type":"function"},{"doc":"Returns a version of map whose keys have all been converted to strings.Examplesiex&gt; stringify_keys(%{7 =&gt; 8, &quot;hey&quot; =&gt; &quot;ha&quot;, hi: &quot;ho&quot;}) %{&quot;7&quot; =&gt; 8, &quot;hey&quot; =&gt; &quot;ha&quot;, &quot;hi&quot; =&gt; &quot;ho&quot;}","ref":"PassiveSupport.Map.html#stringify_keys/1","title":"PassiveSupport.Map.stringify_keys/1","type":"function"},{"doc":"Returns a copy of map containing only keys and raises if any are missing.If keys are not provided, returns map unchangedExamplesiex&gt; take!(%{a: &quot;foo&quot;, b: 42, c: :ok}, [:b, :c]) %{b: 42, c: :ok} iex&gt; take!(%{a: &quot;foo&quot;, b: 42}) %{a: &quot;foo&quot;, b: 42} iex&gt; take!(%{&quot;a&quot; =&gt; &quot;foo&quot;, &quot;b&quot; =&gt; 42, &quot;c&quot; =&gt; :ok}, [&quot;c&quot;, &quot;e&quot;]) ** (PassiveSupport.KeysNotFound) Expected to find keys [&quot;c&quot;, &quot;e&quot;] but only found keys [&quot;c&quot;]","ref":"PassiveSupport.Map.html#take!/2","title":"PassiveSupport.Map.take!/2","type":"function"},{"doc":"","ref":"PassiveSupport.Map.html#t:key/0","title":"PassiveSupport.Map.key/0","type":"type"},{"doc":"","ref":"PassiveSupport.MapSet.html","title":"PassiveSupport.MapSet","type":"module"},{"doc":"Adds element to set if it isn't already a member, and deletes it if it is.Examplesiex&gt; MapSet.new([&quot;ketchup&quot;, &quot;pickles&quot;]) ...&gt; |&gt; toggle(&quot;mustard&quot;) ...&gt; |&gt; toggle(&quot;pickles&quot;) ...&gt; |&gt; toggle(&quot;barbecue sauce&quot;) #MapSet&lt;[&quot;barbecue sauce&quot;, &quot;ketchup&quot;, &quot;mustard&quot;]&gt;","ref":"PassiveSupport.MapSet.html#toggle/2","title":"PassiveSupport.MapSet.toggle/2","type":"function"},{"doc":"Mathematical functions.I'm not great at math.","ref":"PassiveSupport.Math.html","title":"PassiveSupport.Math","type":"module"},{"doc":"See :math.acos/1.","ref":"PassiveSupport.Math.html#acos/1","title":"PassiveSupport.Math.acos/1","type":"function"},{"doc":"See :math.acosh/1.","ref":"PassiveSupport.Math.html#acosh/1","title":"PassiveSupport.Math.acosh/1","type":"function"},{"doc":"See :math.asin/1.","ref":"PassiveSupport.Math.html#asin/1","title":"PassiveSupport.Math.asin/1","type":"function"},{"doc":"See :math.asinh/1.","ref":"PassiveSupport.Math.html#asinh/1","title":"PassiveSupport.Math.asinh/1","type":"function"},{"doc":"See :math.atan/1.","ref":"PassiveSupport.Math.html#atan/1","title":"PassiveSupport.Math.atan/1","type":"function"},{"doc":"See :math.atan2/2.","ref":"PassiveSupport.Math.html#atan2/2","title":"PassiveSupport.Math.atan2/2","type":"function"},{"doc":"See :math.atanh/1.","ref":"PassiveSupport.Math.html#atanh/1","title":"PassiveSupport.Math.atanh/1","type":"function"},{"doc":"See Kernel.ceil/1.","ref":"PassiveSupport.Math.html#ceil/1","title":"PassiveSupport.Math.ceil/1","type":"function"},{"doc":"See :math.cos/1.","ref":"PassiveSupport.Math.html#cos/1","title":"PassiveSupport.Math.cos/1","type":"function"},{"doc":"See :math.cosh/1.","ref":"PassiveSupport.Math.html#cosh/1","title":"PassiveSupport.Math.cosh/1","type":"function"},{"doc":"See :math.erf/1.","ref":"PassiveSupport.Math.html#erf/1","title":"PassiveSupport.Math.erf/1","type":"function"},{"doc":"See :math.erfc/1.","ref":"PassiveSupport.Math.html#erfc/1","title":"PassiveSupport.Math.erfc/1","type":"function"},{"doc":"See :math.exp/1.","ref":"PassiveSupport.Math.html#exp/1","title":"PassiveSupport.Math.exp/1","type":"function"},{"doc":"See PassiveSupport.Integer.factorial/1.","ref":"PassiveSupport.Math.html#fact/1","title":"PassiveSupport.Math.fact/1","type":"function"},{"doc":"See Kernel.floor/1.","ref":"PassiveSupport.Math.html#floor/1","title":"PassiveSupport.Math.floor/1","type":"function"},{"doc":"See :math.fmod/2.","ref":"PassiveSupport.Math.html#fmod/2","title":"PassiveSupport.Math.fmod/2","type":"function"},{"doc":"See :math.log/1.","ref":"PassiveSupport.Math.html#log/1","title":"PassiveSupport.Math.log/1","type":"function"},{"doc":"See :math.log10/1.","ref":"PassiveSupport.Math.html#log10/1","title":"PassiveSupport.Math.log10/1","type":"function"},{"doc":"See :math.log2/1.","ref":"PassiveSupport.Math.html#log2/1","title":"PassiveSupport.Math.log2/1","type":"function"},{"doc":"See :math.pi/0.","ref":"PassiveSupport.Math.html#pi/0","title":"PassiveSupport.Math.pi/0","type":"function"},{"doc":"Raises base to the power of exponent.Since :math.pow/2 always does floating point arithmetic, whereas PassiveSupport.Integer.exponential/2 will do arbitrary precision arithmetic if the exponent is a positive integer, Math.pow/2 checks the types of base and exponent and delegates out to the appropriate function based on what it finds.Examplesiex&gt; pow(2, 5) 32 iex&gt; pow(2, 5.0) 32.0 iex&gt; pow(2, 200) 1606938044258990275541962092341162602522202993782792835301376 iex&gt; pow(2.0, 2000) ** (ArithmeticError)","ref":"PassiveSupport.Math.html#pow/2","title":"PassiveSupport.Math.pow/2","type":"function"},{"doc":"Returns 1 if the number is positive, -1 if negative, and 0 if 0","ref":"PassiveSupport.Math.html#sign/1","title":"PassiveSupport.Math.sign/1","type":"function"},{"doc":"See :math.sin/1.","ref":"PassiveSupport.Math.html#sin/1","title":"PassiveSupport.Math.sin/1","type":"function"},{"doc":"See :math.sinh/1.","ref":"PassiveSupport.Math.html#sinh/1","title":"PassiveSupport.Math.sinh/1","type":"function"},{"doc":"See :math.sqrt/1.","ref":"PassiveSupport.Math.html#sqrt/1","title":"PassiveSupport.Math.sqrt/1","type":"function"},{"doc":"See :math.tan/1.","ref":"PassiveSupport.Math.html#tan/1","title":"PassiveSupport.Math.tan/1","type":"function"},{"doc":"See :math.tanh/1.","ref":"PassiveSupport.Math.html#tanh/1","title":"PassiveSupport.Math.tanh/1","type":"function"},{"doc":"Convenience functions and helpers for module introspection","ref":"PassiveSupport.Module.html","title":"PassiveSupport.Module","type":"module"},{"doc":"For a module and export, returns either nil or a tuple describing the export. This function does not retrieve private function or macro arities, as its intended use case is for dynamically finding if a given function or macro can be called upon within a given module, and if so, with how many arguments. ## Examples iex&gt; check_for_export(String, :trim) {:function, [1, 2]} iex&gt; check_for_export(PassiveSupport.Path.Sigil, :sigil_P) {:macro, [2]} iex&gt; check_for_export(Integer, :possibly_private_but_equally_likely_not_to_exist) nil","ref":"PassiveSupport.Module.html#check_for_export/2","title":"PassiveSupport.Module.check_for_export/2","type":"function"},{"doc":"The path sigilimport PassiveSupport.Path.Sigil will make ~P activate various functions within the Path module, for quick and idiomatic usage of filesystem paths. As its default behavior, ~P[path/to/something] will expand to the output of Path.absname(&quot;path/to/something&quot;), but other behaviors can be exposed depending on the modifier provided following the closing delimiter. The enabled modifiers are currently:'a' for Path.absname/1 (default)'b' for Path.basename/1'd' for Path.dirname/1'x' for Path.expand/1'w' for Path.wildcard/1and 'wd' for Path.wildcard(path, match_dot: true)Beyond that, there is no means of modifying function behavior any further, and interpolation through ~p is not yet implemented. They both are on the roadmap for this module, but being that this maintainer fundamentally works on this library in his spare time, the ready date for those functionalities is decidedly TBD.Examplesiex&gt; ~P[foo] Path.absname(&quot;foo&quot;) iex&gt; ~P[bar]a Path.absname(&quot;bar&quot;) iex&gt; ~P[bat]b &quot;bat&quot; iex&gt; ~P[bat/boy]b &quot;boy&quot; iex&gt; ~P[fizz/buzz]d &quot;fizz&quot; iex&gt; ~P[/etc/hosts]d &quot;/etc&quot; iex&gt; ~P[/etc/config.d/nginx.conf]d &quot;/etc/config.d&quot; iex&gt; ~P[./deps/phoenix/lib]x Path.expand(&quot;./deps/phoenix/lib&quot;) iex&gt; ~P[~/.bash_profile]x Path.expand(&quot;~/.bash_profile&quot;) iex&gt; ~P[**/*.txt]w Path.wildcard(&quot;**/*.txt&quot;)","ref":"PassiveSupport.Path.Sigil.html","title":"PassiveSupport.Path.Sigil","type":"module"},{"doc":"","ref":"PassiveSupport.Path.Sigil.html#sigil_P/2","title":"PassiveSupport.Path.Sigil.sigil_P/2","type":"macro"},{"doc":"","ref":"PassiveSupport.PostBody.html","title":"PassiveSupport.PostBody","type":"module"},{"doc":"Deep-parses the map into a string formatted according to the www-form-urlencoded spec.Examplesiex&gt; parse_form_data(%{ ...&gt; &quot;success_url&quot; =&gt; &quot;https://localhost:4001/foo/bert?id={ID}&quot;, ...&gt; &quot;cancel_url&quot; =&gt; &quot;https://localhost:4001/foo/bar&quot;, ...&gt; &quot;payment_types&quot; =&gt; [&quot;cash&quot;, &quot;card&quot;, &quot;cheque&quot;], ...&gt; &quot;line_items&quot; =&gt; [%{&quot;price&quot; =&gt; &quot;five dollars&quot;, &quot;quantity&quot; =&gt; 1}, %{&quot;line&quot; =&gt; &quot;line&quot;, &quot;item&quot; =&gt; &quot;item&quot;}], ...&gt; &quot;mode&quot; =&gt; &quot;subscription&quot;, ...&gt; &quot;just_to_make_sure&quot; =&gt; %{ ...&gt; &quot;we got&quot; =&gt; &quot;all&quot;, &quot;the edge&quot; =&gt; &quot;cases&quot;, &quot;we can think of&quot; =&gt; &quot;covered&quot; ...&gt; } ...&gt; }) ~S(cancel_url=&quot;https://localhost:4001/foo/bar&quot;&amp;just_to_make_sure[the+edge]=cases&amp;just_to_make_sure[we+can+think+of]=covered&amp;just_to_make_sure[we+got]=all&amp;line_items[0][price]=five+dollars&amp;line_items[0][quantity]=1&amp;line_items[1][item]=item&amp;line_items[1][line]=line&amp;mode=subscription&amp;payment_types[0]=cash&amp;payment_types[1]=card&amp;payment_types[2]=cheque&amp;success_url=&quot;https://localhost:4001/foo/bert?id={ID}&quot;) iex&gt; parse_form_data(%{something: :dotcom}) &quot;something=dotcom&quot;","ref":"PassiveSupport.PostBody.html#parse_form_data/1","title":"PassiveSupport.PostBody.parse_form_data/1","type":"function"},{"doc":"Helper functions for working with ranges.Ranges have some interesting characteristics in Elixir. A range literal is the language's simplest representation of a Stream; the use case for them is rather limited compared to other languages; and as of version 1.12.0, it is the first data type in Elixir to make use of a ternary operator (..///3)All of this can mean exactly one thing: Ranges are for lovers. And by virtue of that fact, this library maintainer's personal soft spot for the data type has to be categorical proof that he is, in fact, a lover.This module defines a number of functions that help in determining the characteristics of a range, especially in terms of another range, as well as some functions that aid in manipulating ranges for various use cases — the existence of all of which, as of yet, are unproven. Nevertheless, if any of these hypothetical workflows are eventually found to be extant, these functions will all doubtlessly prove invaluable to whatever intrepid, frontier programmer is brave enough to address the challenging burdens, somehow lightened by these desperate grasps for relevance.","ref":"PassiveSupport.Range.html","title":"PassiveSupport.Range","type":"module"},{"doc":"Returns true if either range begins immediately after the other. Returns false if the ranges have opposing polaritiesExamplesiex&gt; adjacent?(1..5, 6..10) true iex&gt; adjacent?(6..10, 1..5) true iex&gt; adjacent?(10..6, 5..1) true iex&gt; adjacent?(5..1, 10..6) true iex&gt; adjacent?(0..4, 6..10) false iex&gt; adjacent?(6..10, 0..4) false iex&gt; adjacent?(10..6, 1..5) false","ref":"PassiveSupport.Range.html#adjacent?/2","title":"PassiveSupport.Range.adjacent?/2","type":"function"},{"doc":"Returns the first number of the rangeExamplesiex&gt; first(0..5) 0 iex&gt; first(5..0) 5","ref":"PassiveSupport.Range.html#first/1","title":"PassiveSupport.Range.first/1","type":"function"},{"doc":"Returns true if other is a number that falls within range, or if other_range is fully contained within range, regardless of polarity. Returns false for all other values of other.Examplesiex&gt; includes?(1..5, 3) true iex&gt; includes?(1..5, 5) true iex&gt; includes?(1..5, :math.pi) true iex&gt; includes?(1..5, :no) false iex&gt; includes?(1..5, nil) false iex&gt; includes?(1..5, 2..4) true iex&gt; includes?(1..5, 4..6) false iex&gt; includes?(1..5, 0..2) false iex&gt; includes?(5..1, 3) true iex&gt; includes?(5..1, 2..4) true iex&gt; includes?(5..1, 4..2) true","ref":"PassiveSupport.Range.html#includes?/2","title":"PassiveSupport.Range.includes?/2","type":"function"},{"doc":"If the provided ranges overlap or are adjacent, returns a new range spanning the entirety of bothExamplesiex&gt; join(1..5, 6..10) 1..10 iex&gt; join(1..5, 4..8) 1..8 iex&gt; join(10..20, 5..15) 5..20 iex&gt; join(1..10, 2..8) 1..10 iex&gt; join(1..2, 5..10) ** (ArgumentError) Cannot join 1..2 and 5..10 iex&gt; join(1..5, 10..5) ** (ArgumentError) Cannot join 1..5 and 10..5//-1","ref":"PassiveSupport.Range.html#join/2","title":"PassiveSupport.Range.join/2","type":"function"},{"doc":"Returns the last number of the rangeExamplesiex&gt; last(0..5) 5 iex&gt; last(5..0) 0","ref":"PassiveSupport.Range.html#last/1","title":"PassiveSupport.Range.last/1","type":"function"},{"doc":"Returns the larger end of the rangeExamplesiex&gt; max(0..5) 5 iex&gt; max(5..0) 5","ref":"PassiveSupport.Range.html#max/1","title":"PassiveSupport.Range.max/1","type":"function"},{"doc":"Returns the smaller end of the rangeExamplesiex&gt; min(0..5) 0 iex&gt; min(5..0) 0","ref":"PassiveSupport.Range.html#min/1","title":"PassiveSupport.Range.min/1","type":"function"},{"doc":"Returns a new range that immediately follows the range provided, with an equivalent sizeExamplesiex&gt; next_page(1..10) 11..20 iex&gt; next_page(10..1) 0..-9","ref":"PassiveSupport.Range.html#next_page/1","title":"PassiveSupport.Range.next_page/1","type":"function"},{"doc":"Returns true if either end of either range falls within the other. Returns false if the second argument is not a range, or if the ranges have opposing polarities.Examplesiex&gt; overlaps?(1..5, 4..6) true iex&gt; overlaps?(4..6, 1..5) true iex&gt; overlaps?(1..5, 6..7) false iex&gt; overlaps?(1..5, 2..4) true iex&gt; overlaps?(2..4, 1..5) true iex&gt; overlaps?(5..1, 4..6) false iex&gt; overlaps?(4..6, 5..1) false iex&gt; overlaps?(1..5, 6..4) false iex&gt; overlaps?(6..4, 1..5) false iex&gt; overlaps?(6..4, 5..1) true","ref":"PassiveSupport.Range.html#overlaps?/2","title":"PassiveSupport.Range.overlaps?/2","type":"function"},{"doc":"Returns a new range that immediately precedes the range provided, with an equivalent sizeExamplesiex&gt; prev_page(1..10) -9..0 iex&gt; prev_page(10..1) 20..11","ref":"PassiveSupport.Range.html#prev_page/1","title":"PassiveSupport.Range.prev_page/1","type":"function"},{"doc":"Returns the size of the rangeExamplesiex&gt; size(1..5) 5 iex&gt; size(0..5) 6 iex&gt; size(5..0) 6","ref":"PassiveSupport.Range.html#size/1","title":"PassiveSupport.Range.size/1","type":"function"},{"doc":"","ref":"PassiveSupport.Stream.html","title":"PassiveSupport.Stream","type":"module"},{"doc":"Generates a stream of all possible permutations of the given list.Note: The permutations of enumerables containing 32 items or more will not come back in exactly the order you might expect if you are familiar with the general permutation algorithm. This is because PassiveSupport first renders the enumerable into a map, with keys representing each item's index from the list form of the enumerable. The Erlang VM uses a keyword list to represent maps of 31 and fewer items,and a data structure called a trie to represent maps larger than that. Because of how Erlang enumerates the key-value pairs of this trie, the order in which those pairs are presented is not in incrementing order.That said, the order is still deterministic, all permutations of the enumerable will be available by the time the stream is done being processed, and this function scales far more effectively by generating permutations out of this intermediary map than it would by generating them out of the equivalent list.Examplesiex&gt; 1..4 |&gt; permutations |&gt; Enum.take(16) [ [1, 2, 3, 4], [1, 2, 4, 3], [1, 3, 2, 4], [1, 3, 4, 2], [1, 4, 2, 3], [1, 4, 3, 2], [2, 1, 3, 4], [2, 1, 4, 3], [2, 3, 1, 4], [2, 3, 4, 1], [2, 4, 1, 3], [2, 4, 3, 1], [3, 1, 2, 4], [3, 1, 4, 2], [3, 2, 1, 4], [3, 2, 4, 1] ] iex&gt; 1..50 |&gt; permutations |&gt; Enum.take(2) [ [ 34, 13, 45, 24, 30, 48, 31, 44, 40, 46, 49, 27, 47, 32, 12, 38, 10, 33, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 25, 26, 28, 29, 35, 36, 37, 39, 41, 42, 43, 50 ], [ 34, 13, 45, 24, 30, 48, 31, 44, 40, 46, 49, 27, 47, 32, 12, 38, 10, 33, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 25, 26, 28, 29, 35, 36, 37, 39, 41, 42, 50, 43 ] ]","ref":"PassiveSupport.Stream.html#permutations/1","title":"PassiveSupport.Stream.permutations/1","type":"function"},{"doc":"Processes an item while iterating through the provided streamPassiveSupport.Stream.with_memo/3 attaches an arbitrary accumulator acc to the provided enum, and transforms it in relation to each successive item in the enumerable according to the return of fun.(item, acc).Think of it like Stream.with_index/2, but with the abstracted versatility of Enum.reduce/3.In fact, implementing Stream.with_index/2 is possible with PassiveSupport.Stream.with_memo/3iex&gt; with_index = fn enum -&gt; ...&gt; with_memo(enum, -1, fn _el, ix -&gt; ix+1 end) ...&gt; end iex&gt; String.graphemes(&quot;hi world!&quot;) |&gt; with_index.() |&gt; Enum.to_list [{&quot;h&quot;, 0}, {&quot;i&quot;, 1}, {&quot; &quot;, 2}, {&quot;w&quot;, 3}, {&quot;o&quot;, 4}, {&quot;r&quot;, 5}, {&quot;l&quot;, 6}, {&quot;d&quot;, 7}, {&quot;!&quot;, 8} ]By passing false as a fourth argument, evaluate_first, you can return accumulator in the state it was in prior to fun being called.iex&gt; with_memo(?a..?c, &quot;&quot;, fn char, string -&gt; string &lt;&gt; to_string([char]) end) |&gt; Enum.to_list [ {97, &quot;a&quot;}, {98, &quot;ab&quot;}, {99, &quot;abc&quot;} ] iex&gt; with_memo(?a..?c, &quot;&quot;, fn char, string -&gt; string &lt;&gt; to_string([char]) end, false) |&gt; Enum.to_list [ {97, &quot;&quot;}, {98, &quot;a&quot;}, {99, &quot;ab&quot;} ]","ref":"PassiveSupport.Stream.html#with_memo/4","title":"PassiveSupport.Stream.with_memo/4","type":"function"},{"doc":"","ref":"PassiveSupport.String.html","title":"PassiveSupport.String","type":"module"},{"doc":"Returns a copy of string with a newline removed from the end.If there is no newline at the end of string, then it is returned unchangedExamplesiex&gt; chomp(&quot;hello world!\\n&quot;) &quot;hello world!&quot; iex&gt; chomp(&quot;hello\\nworld!&quot;) &quot;hello\\nworld!&quot; iex&gt; chomp(&quot;multiline!\\n\\n&quot;) &quot;multiline!\\n&quot; iex&gt; chomp(&quot;single line!&quot;) &quot;single line!&quot;","ref":"PassiveSupport.String.html#chomp/1","title":"PassiveSupport.String.chomp/1","type":"function"},{"doc":"Splits a string by a given length or lengths.When one length is given, splits the string into a list of substrings of that length.When a list of lengths is given, returns a list of lists of substrings of the given lengths.If the string does not fit within the given length(s), the final substring will be the length of the remainder of the string.To retrieve only the first length or lengths of the string, pass first_split: true. Note that in the case of a single length, this is equivalent to calling String.slice(string, 0..length), or binary_part(string, 0, length). This is useful when, while supplying multiple lengths, only the first lengths of the given string are important to the program, or when the sum of lengths is equal to the length of the original string.Examplesiex&gt; length_split(&quot;hello world!&quot;, 3) [&quot;hel&quot;, &quot;lo &quot;, &quot;wor&quot;, &quot;ld!&quot;] iex&gt; length_split(&quot;hello world!&quot;, 5) [&quot;hello&quot;, &quot; worl&quot;, &quot;d!&quot;] iex&gt; length_split(&quot;hello world!&quot;, 5, first_split: true) &quot;hello&quot; iex&gt; length_split(&quot;Life, the universe, and everything... is pattern-matchable&quot;, [10, 9, 7]) [ [&quot;Life, the &quot;, &quot;universe,&quot;, &quot; and ev&quot;], [&quot;erything..&quot;, &quot;. is patt&quot;, &quot;ern-mat&quot;], [&quot;chable&quot;] ] iex&gt; length_split(&quot;Life, the universe, and everything... is pattern-matchable&quot;, [10, 9, 7], first_split: true) [&quot;Life, the &quot;, &quot;universe,&quot;, &quot; and ev&quot;]","ref":"PassiveSupport.String.html#length_split/3","title":"PassiveSupport.String.length_split/3","type":"function"},{"doc":"Converts the provided pattern to a regular expression, if necessary, and then invokes Regex.run on the expression and the string.Useful for invoking regular expressions on strings in the middle of transformation pipelines.Examplesiex&gt; match(&quot;footwear, fun, and fondue&quot;, &quot;((f[ou])[no]).+&quot;) [&quot;footwear, fun, and fondue&quot;, &quot;foo&quot;, &quot;fo&quot;] iex&gt; match(&quot;fööd!&quot;, &quot;öö&quot;) [&quot;öö&quot;] iex&gt; match(&quot;footwear, fun, and fondue&quot;, ~r/((f[ou])[no]).+/U) [&quot;foot&quot;, &quot;foo&quot;, &quot;fo&quot;]","ref":"PassiveSupport.String.html#match/3","title":"PassiveSupport.String.match/3","type":"function"},{"doc":"Safely casts the string to an atom, returning {:ok, atom} if successful and :error if not.Examplesiex&gt; safe_existing_atom(&quot;ok&quot;) {:ok, :ok} iex&gt; safe_existing_atom(&quot;not_particularly_ok&quot;) :error","ref":"PassiveSupport.String.html#safe_existing_atom/1","title":"PassiveSupport.String.safe_existing_atom/1","type":"function"},{"doc":"Converts the provided pattern to a regular expression, if necessary, and then invokes Regex.scan on the expression and the string.Useful for invoking regular expressions on strings in the middle of transformation pipelines.Examplesiex&gt; scan(&quot;footwear, fun, and fondue&quot;, &quot;((f[ou])[no]).+&quot;) [[&quot;footwear, fun, and fondue&quot;, &quot;foo&quot;, &quot;fo&quot;]] iex&gt; scan(&quot;fööd!&quot;, &quot;öö&quot;) [[&quot;öö&quot;]] iex&gt; scan(&quot;footwear, fun, and fondue&quot;, ~r/((f[ou])[no]).+/U) [[&quot;foot&quot;, &quot;foo&quot;, &quot;fo&quot;], [&quot;fun,&quot;, &quot;fun&quot;, &quot;fu&quot;], [&quot;fond&quot;, &quot;fon&quot;, &quot;fo&quot;]]","ref":"PassiveSupport.String.html#scan/3","title":"PassiveSupport.String.scan/3","type":"function"},{"doc":"","ref":"PassiveSupport.KeysNotFound.html","title":"PassiveSupport.KeysNotFound","type":"exception"},{"doc":"","ref":"PassiveSupport.NonexistentAtoms.html","title":"PassiveSupport.NonexistentAtoms","type":"exception"}]